package fonction;
 /**
 * Classe patron pour toute fonction d'un ensemble de variables.
 *
 * @author Benoit CARRY (version du 07/11/2005)
 * <p>Guillaume BOUBIN, Pierre INIZAN, Mathieu HAVEL et Gatan LE CHAT (version du 03/01/2007)
 * @version
 * 03/01/2007
 * @since Projet Trois Corps 2006
 * 
 */
public interface ChoixDeFonction {

    /**
     * Mthode de calcul pour deux inconnues  dfinir dans une classe herite de celle-ci.
     *
     *  @param variable Inconnue de la fonction
     *  @param parametres Tableau de paramtres dont depend la fonction, le nombre de paramtres dpendant des fonctions cres
     *  @return La valeur de la fonction calcule au point d'entre
     *  @since Projet Trois Corps 2006
     */
  double fonction(double variable, double[] parametres);

    /**
     * Mthode de calcul pour un tableau d'inconnues  dfinir dans une classe herite de celle-ci.
     *
     *  @param variable Tableau d'inconnues de la fonction
     *  @param parametres Tableau de paramtres dont dpend la fonction, le nombre de paramtres dpendant des fonctions cres
     *  @return La valeur de la fonction calcule au point d'entre
     *  @since Projet Trois Corps 2007
     */
  double fonction(double[] variable, double[] parametres);

    /**
     * Mthode de calcul pour un tableau d'inconnues retournant un tableau de valeurs,  dfinir dans une classe hrite de celle-ci.
     *
     *  @param variable Tableau d'inconnues de la fonction
     *  @param parametres Tableau de paramtres dont dpend la fonction, le nombre de paramtres dpendant des fonctions cres
     *  @param taille Dimension retoune du tableau
     *  @return La valeur de la fonction calcule au point d'entre
     *  @since Projet Trois Corps 2007
     */
  double[] fonction_multi(double[] variable, double[] parametres, int taille);
}
