package fonction;
import lagrange.*;
/**
 * Classe permettant d'assigner diverses formes fonctionnelles  deux inconnues  la methode "fonction",  partir du patron ChoixDeFonction.
 *
 * @author Benoit CARRY
 * @version 05/12/2005
 * @since Projet Trois Corps 2006
 */
public class UsineAFonction {

  //////////////////////////////////////////////////////////////
  // Appel des classes de fonction suivant le parametre numEq //
  //////////////////////////////////////////////////////////////


   /**
    * Mthode d'assignation de fonction
    *
    *  @param typeEquation Paramtre de choix de la forme fonctionnelle, prend la valeur "FoncLagrange[i]" ou [i] prend les valeurs 1, 2 ou 3 suivant le point de Lagrange (1, 2 ou 3) voulu
    *  @return La fonction donnant le point fixe desir
    *
    */
  static public ChoixDeFonction creerFonc(String typeEquation) {
    if ( "Lagrange1".equals(typeEquation) ) { return new FoncLagrange1(); }
    else if ( "Lagrange2".equals(typeEquation) ) { return new FoncLagrange2(); }
    else { return new FoncLagrange3(); }
  }


   /**
    * Mthode d'assignation de derive de fonction
    *
    *  @param typeEquation Paramtre de choix de la forme fonctionnelle de la derive, prend la valeur "DerivLagrange[i]" ou [i] prend les valeurs 1, 2 ou 3 suivant le point de Lagrange (1, 2 ou 3) voulu
    *  @return La derive de la fonction donnant le point fixe voulu
    *
    */
  static public ChoixDeFonction creerDer(String typeEquation) {
    if ( "Lagrange1".equals(typeEquation) ) { return new DerivLagrange1(); }
    else if ( "Lagrange2".equals(typeEquation) ) { return new DerivLagrange2(); }
    else  { return new DerivLagrange3(); }
  }

}
