package vitessenulle;
import fonction.ChoixDeFonction;
import java.lang.Math;
/**
 * Classe de fonction donnant la derive de la position du point de vitesse nulle de mme ordone que le point d'origine.
 *
 * Hrite de la classe ChoixDeFonction
 *
 * @author Guillaume BOUBIN et Gatan LE CHAT
 * @version 09/01/2007
 * @since Projet Trois Corps 2007
 */
class DeriveVitesseNulle implements ChoixDeFonction {

  /**
  *fonction donnant la derive de la position du point de vitesse nulle de mme ordone que le point d'origine
  *@param variable inconnue (ici q2)
  *@param parametres liste des parametres de la fonction (Jacobien, mu, q1 de l'origine)
  */
  public double fonction(double variable, double[] parametres) {
    double resultat ;
    double bloc;

    bloc = (((1.0 - parametres[1])*(variable))/(Math.pow((Math.pow(parametres[2] + parametres[1], 2.0) + variable * variable), 1.5)) + (parametres[1] * variable)/(Math.pow((Math.pow(parametres[2] + parametres[1] - 1.0, 2.0) + variable * variable), 1.5)));

    resultat = 2.0 * variable- 2.0 * bloc;

    return resultat ;
  
    }

  /**
  *definition de la methode fonction non utilise dans ce cas
  */
  public double fonction(double[] variable, double[] parametres) {
    double resultat = 0;
    return resultat;
    }

  /**
  *definition de la methode fonction_multi non utilise dans ce cas
  */
  public double[] fonction_multi(double[] variable, double[] parametres, int taille) {
    double[] resultat = new double[1];
    resultat[0] = 0;
    return resultat;
    }
}
