package vitessenulle;
import fonction.ChoixDeFonction;
import java.lang.Math;
/**
 * Classe de fonction donnant la derivee  de Q1 et Q2 en fonction de l'absice curviligne ds, utilise par CourbeVitesse0(integrateur).
 *
 * Herite de la classe ChoixDeFonction
 *
 * @author Guillaume BOUBIN et Gatan LE CHAT
 * @version 07/11/2006
 * @since Projet Trois Corps 2007
 */
class Dqds implements ChoixDeFonction {
  /**
  *fonction donnant la derivee  de Q1 et Q2 en fonction de l'absice curviligne ds
  *@param variable liste des inconnues (ici q1 et q2)
  *@param parametres liste des parametres de la fonction (mu, a et b - signe de dQ1 et dQ2 respectivement)
  *@param taille taille du tableau retournee (ici 2)
  *@return tableau (q1_dot, q2_dot)
  */
  public double[] fonction_multi(double[] variable, double[] parametres, int taille) {
    double[] resultat = new double[taille] ;
  
    //calcul des derivees partielles
  
    DerivePartQ1 derivQ1 = new DerivePartQ1();
    DerivePartQ2 derivQ2 = new DerivePartQ2();
  
    double dfsurdQ1;
    double dfsurdQ2;
  
    dfsurdQ1 = derivQ1.fonction(variable, parametres);
    dfsurdQ2 = derivQ2.fonction(variable, parametres);
    
    //calcul de q1_dot et q2_dot  renvoyes dans resultat[]

    resultat[0] = -dfsurdQ2*(Math.pow(Math.pow(dfsurdQ1 ,2.0) + Math.pow(dfsurdQ2 ,2.0) ,(-0.5)));
    resultat[1] = dfsurdQ1*(Math.pow(Math.pow(dfsurdQ1 ,2.0) + Math.pow(dfsurdQ2 ,2.0) ,(-0.5)));  

    return resultat ;
    }
  
  /**
  *definition de la methode fonction non utilise dans ce cas
  */
  public double fonction(double variable, double[] parametres) {
    double resultat = 0;
    return resultat;
    }

  /**
  *definition de la methode fonction non utilise dans ce cas
  */
  public double fonction(double[] variable, double[] parametres) {
    double resultat = 0;
    return resultat;
    }
}
