package vitessenulle;
import fonction.ChoixDeFonction;
import java.lang.Math;
/**
 * Classe de fonction donnant la position du point de vitesse nulle de mme absice qu'un point particulier (souvent point de Lagrange).
 *
 * Herite de la classe ChoixDeFonction
 *
 * @author Guillaume BOUBIN et Gatan LE CHAT
 * @version 09/01/2007
 * @since Projet Trois Corps 2007
 */
class FoncQ1VitesseNul implements ChoixDeFonction {
  /**
  *fonction donnant la position du point de vitesse nulle de mme absice qu'un point particulier (souvent point de Lagrange)
  *@param variable inconnue (ici q1)
  *@param parametres liste des parametres de la fonction (Jacobien, mu, q1 d'origine, q2 d'origine)
  */
  public double fonction(double variable, double[] parametres) {
    double resultat;
    double r1, r2;
    
    r1 = Math.sqrt(Math.pow((variable + parametres[1]), 2.0) + parametres[3]*parametres[3]);
    r2 = Math.sqrt(Math.pow((variable + parametres[1] - 1.0), 2.0) + parametres[3]*parametres[3]);
     
    resultat = variable*variable +  parametres[3]*parametres[3] + 2.0*((1.0 - parametres[1])/r1 + parametres[1]/r2) - parametres[0];

    return resultat;
    }

  /**
  *definition de la methode fonction non utilise dans ce cas
  */
  public double fonction(double[] variable, double[] parametres) {
    double resultat = 0;
    return resultat;
    }

  /**
  *definition de la methode fonction_multi non utilise dans ce cas
  */
  public double[] fonction_multi(double[] variable, double[] parametres, int taille) {
    double[] resultat = new double[1];
    resultat[0] = 0;
    return resultat;
    }
}
